﻿using System;
using Android.App;
using Android.Runtime;
using Android.Util;
using AndroidX.Lifecycle;
using Java.Interop;

namespace App1
{
    [Application]
    public class MyApplication : Application, ILifecycleObserver
    {
        private const string Tag = nameof(App1);

        public MyApplication(IntPtr javaReference, JniHandleOwnership transfer)
            : base(javaReference, transfer)
        {
        }

        public override void OnCreate()
        {
            base.OnCreate();

            var lifecycleOwner = ProcessLifecycleOwner.Get();
            Log.Info(Tag, "Will crash...");
            var lifecycle = lifecycleOwner.Lifecycle;
            Log.Info(Tag, "You won't see this");
            lifecycle.AddObserver(this);
        }

        [Lifecycle.Event.OnStart]
        [Export]
        public void OnStart()
        {
            Log.Info(Tag, "MyApplication.OnStart");
        }
	}
}
